/**********************************************************************/
/* Many-Core Architecture Research Project       Arch Lab. TOKYO TECH */
/**********************************************************************/
#include "MClib.h"

volatile int buf;

/**********************************************************************/
int main(int argc, char *args[])
{
    int id_x, id_y, rank_x, rank_y;
    MC_init(&id_x, &id_y, &rank_x, &rank_y);

    buf = 0;

    if (id_x == rank_x && id_y == rank_y) {
        MC_sleep(10000);
        int dst = 0;
        setidxy(&dst, 1, 1);
        MC_dma_put_4b(dst, (int*)&buf, 777);
    }

    if (id_x == 1 && id_y == 1) {
        while(buf == 0);
        printf("buf %d (this must be 777)\n", buf);
    }

    MC_finalize();
    return 0;
}

/**********************************************************************/
