/**********************************************************************/
/* Many-Core Architecture Research Project       Arch Lab. TOKYO TECH */
/**********************************************************************/
#include "MClib.h"

int array[1024];

/**********************************************************************/
int main(int argc, char *args[])
{
    int i;
    int id_x, id_y, rank_x, rank_y;
    MC_init(&id_x, &id_y, &rank_x, &rank_y);

    for (i = 0; i < 1024; i++)
        array[i] = 0;

    if (id_x == rank_x && id_y == rank_y) {
        for (i = 0; i < 1024; i++)
            array[i] = i;
        int size = 64;
        int src_stride = 12;
        int dst_stride = 4;
        int dst = 0;
        setidxy(&dst, 1, 1);
        MC_dma_put(dst, &array, &array, size, dst_stride, src_stride);
    }

    MC_sleep(2000);
    if (id_x == 1 && id_y == 1) {
        for (i = 0; i < 50; i++)
            printf("array[%2d] %4d\n", i, array[i]);
    }

    MC_finalize();
    return 0;
}

/**********************************************************************/
